component: TrajectoryManagerFaults
proto_imports:
  - vehicle/ai_monitor/trajectory_manager/diagnostics/diagnostics.proto
metric: zoox::diag::EmptyMetric
namespace: zoox::ai_monitor
faults:
    # Deprecated. See AnyNoGoTriggeredWarn.
  - id: 0
    name: NOGO_TRIGGERED
    severity: WARNING
    description: Nogo trajectory triggered.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    deprecated: true
    # Deprecated.
  - id: 1
    name: NOGO_DISARMED
    severity: WARNING
    description: Nogo is disarmed, e.g. due to swopdash selector or rove bot mode.
    deprecated: true
    # Deprecated.
  - id: 2
    name: CAT_TRIGGERED
    severity: WARNING
    description: Cat trajectory triggered.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    deprecated: true
    # Deprecated.
  - id: 3
    name: ESTOP_TRIGGERED
    severity: ERROR
    description: Emergency stop triggered due to forwarding of AI unavailable state.
    triggers_nogo: true
    deprecated: true
    # Deprecated. See MonitorSystemExecutionError.
  - id: 4
    name: SystemExecutionRequirementsNotMet
    severity: ERROR
    description: AI Monitor is faulted internally due to external system level
      requirements (e.g. scheduling) not being met.
    triggers_nogo: true
    deprecated: true
    # Deprecated.
  - id: 5
    name: CAS_NOGO_TRIGGERED
    severity: ERROR
    description: CAS detected a problem with Go trajectory. Executing NoGo.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    triggers_nogo: true
    deprecated: true
    # Deprecated.
  - id: 6
    name: CAS_CAT_TRIGGERED
    severity: ERROR
    description: CAS detected a problem with Go/NoGo trajectories. Executing CAT.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    triggers_nogo: true
    deprecated: true
    # Deprecated.
  - id: 7
    name: CAS_ESTOP_TRIGGERED
    severity: ERROR
    description: CAS detected a problem with Go/NoGo/C-NoGo trajectories.
      Executing ESTOP by forwarding of AI unavailable state.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    triggers_nogo: true
    deprecated: true
    # Deprecated. See GoCollisionImminentWarn.
  - id: 8
    name: CAS_COLLISION_WARNING
    severity: WARNING
    description: CAS detected collision(s) in the Go trajectory with sometime
      (e.g. 1 second) until intervention is needed to avoid the collision.
    deprecated: true
    # Deprecated. See TooManyDetectedCollisionsWarn.
  - id: 9
    name: TOO_MANY_DETECTED_COLLISIONS
    severity: WARNING
    description: Detecting Collision(s) with Go/NoGo/C-NoGo trajectories has
      met capacity resulting in only the nearest collisions being realized.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    deprecated: true
    # Deprecated.
  - id: 10
    name: TrajectoryValidationError
    severity: ERROR
    description: CAS detected one or more problem(s) with Go/NoGo/C-NoGo
      trajectories.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    triggers_nogo: true
    deprecated: true
    # Deprecated. See AnyCNoGoTriggeredWarn.
  - id: 11
    name: CNOGO_TRIGGERED
    severity: WARNING
    description: C-NoGo trajectory triggered.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    deprecated: true
    # Deprecated.
  - id: 12
    name: CAS_CNOGO_TRIGGERED
    severity: ERROR
    description: CAS detected a problem with Go/NoGo trajectories. Executing
      C-NoGo.
    freeze_frame: zoox.ai_monitor.proto.TrajectoryManagerFreezeFrame
    triggers_nogo: true
    deprecated: true
  - id: 13
    name: AutonomyValidationError
    severity: ERROR
    description: CAS detected an autonomous state mismatch between Planner and
      Hero State (from LLC/EMU). One is autonomous and the other is not. For a
      mission to continue, both entities must agree in state.
    troubleshooting_steps: Check the Planner and Drivers capability for any
      other errors and note. Once Hero is stopped, consider toggling Planner
      capability first to resolve the issue. If unsuccessful, cycle the EMU or
      LLC.
    freeze_frame: zoox.ai_monitor.proto.AutonomyValidationFreezeFrame
    triggers_nogo: true
  - id: 14
    name: LivenessValidationError
    severity: ERROR
    description: CAS detected one or more critical input(s) exceeds its
      expected publish cadence and/or input(s) are found with a published
      timestamp after this component's current tick (now).
    troubleshooting_steps: Check Planner and (Pose + Localizer) capabilities
      for any other errors and note. If the error persists once Hero is
      stopped, consider toggling Planner capability first to resolve the
      issue. If unsuccessful, teardown capabilities and bring them all back
      online to a healthy state.
    freeze_frame: zoox.ai_monitor.proto.LivenessValidationFreezeFrame
    triggers_nogo: true
  - id: 15
    name: FeasibilityValidationError
    severity: ERROR
    description: CAS detected a trajectory that is NOT feasible. The
      trajectory is NOT within the dynamic limits of the vehicle platform OR is
      dynamically inconsistent.
    troubleshooting_steps: Check the Planner capability for any errors and
      note. If there are no Planner errors, check for any NoGo generation
      errors reported by CAS and note. Next, if the error persists once Hero
      is stopped, consider toggling Planner capability first to resolve the
      issue. If unsuccessful, teardown capabilities and bring them all back
      online to a healthy state.
    freeze_frame: zoox.ai_monitor.proto.FeasibilityValidationFreezeFrame
    triggers_nogo: true
  - id: 16
    name: ConsistencyValidationError
    severity: ERROR
    description: CAS detected a planned trajectory that is NOT consistent with
      the current Hero State or previously tracked Hero Trajectory. This error
      is indicative of a jump between the current planned trajectory and Hero
      State or the previously tracked Hero Trajectory.
    troubleshooting_steps: Check the Planner capability for any errors and
      note. If there are no Planner errors, check for any NoGo generation
      errors reported by CAS and note. Next, if the error persists once Hero
      is stopped, consider toggling Planner capability first to resolve the
      issue. If unsuccessful, teardown capabilities and bring them all back
      online to a healthy state.
    freeze_frame: zoox.ai_monitor.proto.ConsistencyValidationFreezeFrame
    triggers_nogo: true
  - id: 17
    name: CollisionValidationError
    severity: ERROR
    description: CAS detected an imminent collision between the currently
      planned (Hero) trajectory and one or more agent(s) predicted trajectories.
    troubleshooting_steps: Check the Planner capability for any errors and
      note. If there are no Planner errors, check for any NoGo generation
      errors reported by CAS and note. Next, if the error persists once Hero
      is stopped, consider toggling Planner capability first to resolve the
      issue. If unsuccessful, teardown capabilities and bring them all back
      online to a healthy state.
    freeze_frame: zoox.ai_monitor.proto.CollisionValidationFreezeFrame
    triggers_nogo: true
  - id: 18
    name: NoGoTrajectoryGenerationError
    severity: ERROR
    description: A stopping trajectory could not be generated from the Planner
      Go trajectory. Check freeze frame information for more details as to why.
    troubleshooting_steps: Check the Planner capability for any errors and
      note. If the error persists once Hero is stopped, consider toggling
      Planner capability first to resolve the issue. If unsuccessful, teardown
      capabilities and bring them all back online to a healthy state.
    freeze_frame: zoox.ai_monitor.proto.NoGoGenerationFreezeFrame
    triggers_nogo: true
  - id: 19
    name: CNoGoTrajectoryGenerationError
    severity: ERROR
    description: A stopping trajectory could not be generated from the Planner
      Go trajectory. Check freeze frame information for more details as to why.
    troubleshooting_steps: Check the Planner capability for any errors and
      note. If the error persists once Hero is stopped, consider toggling
      Planner capability first to resolve the issue. If unsuccessful, teardown
      capabilities and bring them all back online to a healthy state.
    freeze_frame: zoox.ai_monitor.proto.NoGoGenerationFreezeFrame
    triggers_nogo: true
  - id: 20
    name: TooManyDetectedCollisionsWarn
    severity: WARNING
    description: Detecting collision(s) with one or more Go/NoGo/C-NoGo
      trajectories has met capacity resulting in only a set of nearest
      collisions, as determined by time to intervention, being realized.
      Ideally, all agents should be detected for collisions, but due to
      memory constraints limits must be realized.
    freeze_frame: zoox.ai_monitor.proto.TooManyDetectedCollisionsFreezeFrame
  - id: 21
    name: GoCollisionImminentWarn
    severity: WARNING
    description: CAS detected collision(s) in the Go trajectory with some
      minimal time (e.g. 1 second) until intervention is needed to avoid the
      collision.
  - id: 22
    name: MonitorSystemExecutionError
    severity: ERROR
    description: This monitor is faulted internally due to one or more system
      level requirements not being met. Ideally, all critical inputs shall be
      received in a timely manner and this system be executed on a healthy
      cadence. Check freeze frame information for more details as to why.
    troubleshooting_steps: Check Drivers and NoGo capabilities for any errors
      and note. If the error persists once Hero is stopped, consider toggling
      NoGo capability first to resolve the issue. If unsuccessful, teardown
      capabilities and bring them all back online to a healthy state. You may
      also have to toggle the LLC/EMU if errored.
    freeze_frame: zoox.ai_monitor.proto.MonitorSystemExecutionFreezeFrame
    triggers_nogo: true
  - id: 23
    name: AnyNoGoTriggeredWarn
    severity: WARNING
    description: A NoGo was triggered due to one or more errors associated with
      the driving stack. Check freeze frame information for more details as to
      why.
    troubleshooting_steps: Check all capabilities for any errors and note. If
       the error persists once Hero is stopped, consider taking measures to
       resolve all faulted capabilities. If those measures were unsuccessful,
       teardown capabilities and bring them all back online to a healthy state.
       Otherwise, there are no remaining errors and the mission can continue so
       try to release this NoGo by double tapping cruise stalk or pressing the
       NoGo button.
    freeze_frame: zoox.ai_monitor.proto.AnyNoGoTriggeredFreezeFrame
  - id: 24
    name: AnyCNoGoTriggeredWarn
    severity: WARNING
    description: A C-NoGo was triggered due to one or more errors associated
      with the driving stack. Check freeze frame information for more details
      as to why.
    troubleshooting_steps: Check all capabilities for any errors and note. If
       the error persists once Hero is stopped, consider taking measures to
       resolve all faulted capabilities. If those measures were unsuccessful,
       teardown capabilities and bring them all back online to a healthy state.
       Otherwise, there are no remaining errors and the mission can continue so
       try to release this NoGo by double tapping cruise stalk or pressing the
       NoGo button.
    freeze_frame: zoox.ai_monitor.proto.AnyCNoGoTriggeredFreezeFrame
  - id: 25
    name: TooManyPredictionsWarn
    severity: WARNING
    description: Could not account for all agent predictions. There are too
      many tracks to follow. Ideally, all agents should be detected for
      collisions, but due to memory constraints limits must be realized.
    freeze_frame: zoox.ai_monitor.proto.TooManyPredictionsFreezeFrame
  - id: 99
    name: NoCASForZabotageWarn
    severity: WARNING
    description: Zabotage is enabled so the collision avoidance system is
      partially enabled to not intefere with driver training. Checks disabled
      are collision, consistency, and feasibility.
  - id: 100
    name: CollisionCheckDisabledWarn
    severity: WARNING
    description: Collision check is disabled for one or more Go/NoGo/C-NoGo
      trajectories and/or one or more perception sources (AI and/or Safety).
      The collision avoidance system is not in a nominal state of operation.
      Please take caution since not all collisions maybe avoided as when
      operating nominally.
    freeze_frame: zoox.ai_monitor.proto.CollisionValidationDisabledFreezeFrame
